<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List Đơn Hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="text-center mt-2 mb-2">
            <h2>Danh Sách Đơn Hàng</h2>
        </div>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-sm-5">
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label>Trạng thái Order</label>
                        </div>
                        <div class="col-sm-8">
                            <select id="select-order" class="form-control"></select>
                        </div>
                    </div>
                </div>
                <div class="col-sm-5">
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label>Loại Pizza</label>
                        </div>
                        <div class="col-sm-8">
                            <select id="select-loai-pizza" class="form-control"> </select>
                        </div>
                    </div>
                </div>
                <div class="col-sm-2">
                    <button id="btn-tim-kiem" class="btn btn-success">Tìm kiếm</button>
                </div>
            </div>
        </div>

        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="user-table">
                <thead>
                    <tr>
                        <th>Order ID</th>
                        <th>Kích cỡ Combo</th>
                        <th>Loại Pizza</th>
                        <th>Nước uống</th>
                        <th>Thành tiền</th>
                        <th>họ và tên</th>
                        <th>Số điện thoại</th>
                        <th>Trạng thái</th>
                        <th style="width: 150px">Action</th>
                    </tr>
                </thead>
            </table>
        </div>

        <!--Modal hiển thị chi tiết đon hàng-->
        <div class="modal fade" id="modal-order" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-warning text-white">
                        <h5 class="modal-title" id="exampleModalLabel">Order Detai!!!</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="container p-3">
                            <div class="form-group">
                                <label for="inp-ma-don-hang">order ID(mã đơn hàng):</label>
                                <input id="inp-ma-don-hang" name="inp-ma-don-hang" placeholder="..." type="text"
                                    class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-combo">Cỡ Combo:</label>
                                <input id="inp-combo" name="inp-combo" placeholder="..." type="text"
                                    class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-duong-kinh">Đường kính Pizza</label>
                                <input id="inp-duong-kinh" name="inp-duong-kinh" placeholder="..." type="text"
                                    class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-suon">Sườn nướng(miếng)</label>
                                <input id="inp-suon" name="inp-suon" placeholder="..." type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-do-uong">Đồ uống</label>
                                <input id="inp-do-uong" name="inp-do-uong" placeholder="..." type="text"
                                    class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-so-luong-nuoc">Số lượng nước uống</label>
                                <input id="inp-so-luong-nuoc" name="inp-so-luong-nuoc" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-voucher-id">Voucher ID</label>
                                <input id="inp-voucher-id" name="inp-voucher-id" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-loai-pizza">Loại pizza</label>
                                <input id="inp-loai-pizza" name="inp-loai-pizza" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-salad">Salad</label>
                                <input id="inp-salad" name="inp-salad" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-thanh-tien">Thành tiền</label>
                                <input id="inp-thanh-tien" name="inp-thanh-tien" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-giam-gia">Giảm giá</label>
                                <input id="inp-giam-gia" name="inp-giam-gia" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-ho-ten">Họ và tên</label>
                                <input id="inp-ho-ten" name="inp-ho-ten" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-email">Email</label>
                                <input id="inp-email" name="inp-email" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-so-dien-thoai">Số điện thoại</label>
                                <input id="inp-phone" name="inp-so-dien-thoai" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-dia-chi">Địa chỉ</label>
                                <input id="inp-dia-chi" name="inp-dia-chi" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-loi-nhan">Lời nhắn</label>
                                <input id="inp-loi-nhan" name="inp-loi-nhan" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-trang-thai-don-hang">Trạng thái đơn hàng</label>
                                <input id="inp-trang-thai-don-hang" name="inp-trang-thai-don-hang" type="text"
                                    class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-ngay-tao-don">Ngày tạo đơn</label>
                                <input id="inp-ngay-tao-don" name="inp-ngay-tao-don" type="text" class="form-control">
                            </div>
                            <div class="form-group">
                                <label for="inp-ngay-cap-nhat">Ngày cập nhật</label>
                                <input id="inp-ngay-cap-nhat" name="inp-ngay-cap-nhat" type="text" class="form-control">
                            </div>
                            <div class="float-right">
                                <button type="button" class="btn btn-success" id="btn-confirm">Confirm</button>
                                <button type="button" class="btn btn-danger" id="btn-cancel">Cancel</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gNameCols = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action",];
        const gORDER_ID_COL = 0;
        const gORDER_KICH_CO_COL = 1;
        const gORDER_LOAI_PIZZA_COL = 2;
        const gORDER_LOAI_NUOC_UONG_COL = 3;
        const gORDER_THANH_TIEN_COL = 4;
        const gORDER_HO_TEN_COL = 5;
        const gORDER_PHONE_COL = 6;
        const gORDER_TRANG_THAI_COL = 7;
        const gORDER_ACTION_COL = 8;

        var gDataOrder = null;
        var gStatus = "";
        var gOderId = "";
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        // gán sự kiện tải trang
        onPageLoading();
        // gán sự kiện lọc dữ liệu
        $("#btn-tim-kiem").on("click", filterData);
        // gán sự kiện khi ấn nút chi tiết
        $("#user-table").on("click", ".btn-chi-tiet", function () {
            onBtnChiTietClick(this);
        });
        // gán sự kiện khi ấn nút Confirm
        $("#btn-confirm").on("click", onBtnConfirmClick)
         // gán sự kiện khi ấn nút Confirm
         $("#btn-cancel").on("click", onBtnCancelClick)

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm xử lý sự kiện khi tải trang
        function onPageLoading() {
            // load dữ liệu vào dataTable
            loadDataToTable();
            // load dữ liệu vào ô select trạng thái Order
            loadSelectOrder();
            // load dữ liệu vào ô select loại pizza
            loadSelectPizza();
        };
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // HÀM LOAD DỮ LIỆU VÀO TABLE
        function loadDataToTable() {
            "use strict";
            $("#user-table").DataTable({
                columns: [
                    { data: gNameCols[gORDER_ID_COL] },
                    { data: gNameCols[gORDER_KICH_CO_COL] },
                    { data: gNameCols[gORDER_LOAI_PIZZA_COL] },
                    { data: gNameCols[gORDER_LOAI_NUOC_UONG_COL] },
                    { data: gNameCols[gORDER_THANH_TIEN_COL] },
                    { data: gNameCols[gORDER_HO_TEN_COL] },
                    { data: gNameCols[gORDER_PHONE_COL] },
                    { data: gNameCols[gORDER_TRANG_THAI_COL] },
                    { data: gNameCols[gORDER_ACTION_COL] },
                ],
                columnDefs: [
                    {
                        targets: gORDER_ACTION_COL, //cột Action
                        className: "text-center",
                        defaultContent: `
                    <div class="action-group">
                    <button class="btn btn-success btn-chi-tiet" data-toggle="tooltip" data-placement="bottom" >Chi tiết</button>`,
                    },
                ],
            });
            getDataFromSever();
        };

        // Hàm gọi sever để lấy dữ liệu
        function getDataFromSever() {
            $.ajax({
                url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
                type: "GET",
                dataType: "json",
                success: function (responseObject) {
                    //debugger;
                    gDataOrder = responseObject;
                    console.log(gDataOrder);
                    // hiênt hị dữ liệu
                    hienThiDataToTable(gDataOrder);
                },
                error: function (error) {
                    console.assert(error.responseText);
                },
            });
        };
        // hàm hiển yhij dữ liệu lên bảng
        function hienThiDataToTable(paramObjResult) {
            "use strict";
            var vTable = $("#user-table").DataTable(); // Truy xuất DataTable
            vTable.clear(); // Xóa dữ liệu cũ trước khi thêm mới
            vTable.rows.add(paramObjResult); // Thêm các dòng dữ liệu vào DataTable
            vTable.draw(); // Vẽ lại DataTable
        };
        // hàm load dữ liệu vào ô select trạng thái Order
        function loadSelectOrder() {
            var vOrderStatus = ["open", "confirmed", "cancel"];
            // load vào select mặc đinh
            $('#select-order').append($('<option>', {
                value: 0,
                text: '---Chọn trạng thái Order---'
            }));

            for (var bI = 0; bI < vOrderStatus.length; bI++) {
                $('#select-order').append($('<option>', {
                    value: vOrderStatus[bI],
                    text: vOrderStatus[bI],
                }));
            }
        };
        // hàm load dữ liệu vào ô select Loại pizza
        function loadSelectPizza() {
            var vPizzaName = ["Hawaiian", "Bacon", "Seafood"];
            // load vào select mặc đinh
            $('#select-loai-pizza').append($('<option>', {
                value: 0,
                text: '---Chọn loại Pizza---'
            }));

            for (var bI = 0; bI < vPizzaName.length; bI++) {
                $('#select-loai-pizza').append($('<option>', {
                    value: vPizzaName[bI],
                    text: vPizzaName[bI],
                }));
            }
        };
        // Hàm lọc dữ liệu
        function filterData() {
            var vSelectOrderStatus = $("#select-order").val();
            var vSelectOrderPizzaName = $("#select-loai-pizza").val();
            var paramFilterDataObj = {
                status: vSelectOrderStatus,
                pizzatype: vSelectOrderPizzaName,
            };
            var vUserResult = [];
            vUserResult = gDataOrder.filter(function (paramUser) {
                return (
                    (paramFilterDataObj.status === paramUser.trangThai || paramFilterDataObj.status === "0")
                    && (paramFilterDataObj.pizzatype === paramUser.loaiPizza || paramFilterDataObj.pizzatype === "0")
                );
            });
            console.log(vUserResult);
            hienThiDataToTable(vUserResult);
            return vUserResult;
        };
        // HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT CHI TIẾT
        function onBtnChiTietClick(paramElement) {
            "use strict";
            var vRowClick = $(paramElement).closest("tr");
            var vTable = $("#user-table").DataTable();
            var vDataRow = vTable.row(vRowClick).data();
            var vOrderId = vDataRow.orderId;
            console.log(vOrderId);
            $("#modal-order").modal("show");
            var vOrderObject = getOrderById(vOrderId);
            loadDataToModal(vOrderObject);
        };
        // hàm nhận dữ liệu thông qua orderId
        function getOrderById(paramOrderId) {
            "use trict"
            var vOrderObject = null;
            for (var bI = 0; bI < gDataOrder.length; bI++) {
                if (paramOrderId == gDataOrder[bI].orderId) {
                    vOrderObject = gDataOrder[bI];
                }
            }
            return vOrderObject;
        };
        // HÀM LOAD DỮ LIỆU LÊN MODAL ORDER CHI TIET
        function loadDataToModal(paramOrderObject) {
            makeValueToInput("#inp-ma-don-hang", paramOrderObject.id);
            makeValueToInput("#inp-combo", paramOrderObject.kichCo);
            makeValueToInput("#inp-duong-kinh", paramOrderObject.duongKinh);
            makeValueToInput("#inp-suon", paramOrderObject.suon);
            makeValueToInput("#inp-do-uong", paramOrderObject.idLoaiNuocUong);
            makeValueToInput("#inp-so-luong-nuoc", paramOrderObject.soLuongNuoc);
            makeValueToInput("#inp-voucher-id", paramOrderObject.idVourcher);
            makeValueToInput("#inp-loai-pizza", paramOrderObject.loaiPizza);
            makeValueToInput("#inp-salad", paramOrderObject.salad);
            makeValueToInput("#inp-thanh-tien", paramOrderObject.thanhTien);
            makeValueToInput("#inp-giam-gia", paramOrderObject.giamGia);
            makeValueToInput("#inp-ho-ten", paramOrderObject.hoTen);
            makeValueToInput("#inp-email", paramOrderObject.email);
            makeValueToInput("#inp-so-dien-thoai", paramOrderObject.soDienThoai);
            makeValueToInput("#inp-dia-chi", paramOrderObject.diaChi);
            makeValueToInput("#inp-loi-nhan", paramOrderObject.loiNhan);
            makeValueToInput("#inp-trang-thai-don-hang", paramOrderObject.trangThai);
            makeValueToInput("#inp-ngay-tao-don", paramOrderObject.ngayTao);
            makeValueToInput("#inp-ngay-cap-nhat", paramOrderObject.ngayCapNhat);
            console.log(paramOrderObject);
        };
        // hàm makeValuetoinput
        function makeValueToInput(paramInputId, paramValue) {
            $(paramInputId).val(paramValue);
        };
        // HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT CONFIRM
        function onBtnConfirmClick() {
            "use strict";
            console.log("Nút confirm được ấn");
            var vObjectRequest = { trangThai: "Confirmed" };   //3 trang thai open, confirmed, cancel
            // B1 thu thập dữ liệu (ko có)
            // B2 kiểm tra dữ liệu (ko có)
            // B3 gọi Api đê cập nhật trạng thái
            var vUserId = $("#inp-ma-don-hang").val();
            callApiToStatus(vUserId, vObjectRequest);
        };
         // HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT CANCEL
         function onBtnCancelClick() {
            "use strict";
            console.log("Nút cancel được ấn");
            var vObjectRequest = { trangThai: "Cancel" };   //3 trang thai open, confirmed, cancel
            // B1 thu thập dữ liệu (ko có)
            // B2 kiểm tra dữ liệu (ko có)
            // B3 gọi Api đê cập nhật trạng thái
            var vUserId = $("#inp-ma-don-hang").val();
            callApiToStatus(vUserId, vObjectRequest);
        };
        // HÀM GỌI API ĐỂ CẬP NHẬT TRẠNG THÁI CONFIRM
        function callApiToStatus(paramUserId, paramObjectRequest) {
            "use strict";
            var vJSONString = JSON.stringify(paramObjectRequest);
            // alert(paramOrderId);
            $.ajax({
                type: "PUT",
                url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + paramUserId,
                data: vJSONString,
                contentType: "application/json",
                success: function (response) {
                    alert("Cập nhật trạng thái thành công");
                    console.log("res trả về: ")
                    console.log(response);
                    $("#modal-order").modal("hide");
                    window.location.reload();
                },
            });
        };
    });
    
</script>

</html>